//Displaying Mapping Mode Example//
#include <windows.h>
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
WNDCLASSEX wc;
MSG msg;
wc.cbSize = sizeof(WNDCLASSEX);
wc.style = 0;
wc.lpfnWndProc = WndProc;
wc.cbClsExtra = 0;
wc.cbWndExtra = 0;
wc.hInstance = hInstance;
wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
wc.hCursor = LoadCursor(NULL, IDC_ARROW);
wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
wc.lpszMenuName = NULL;
wc.lpszClassName = TEXT("myWindowClass");
wc.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
RegisterClassEx(&wc);
CreateWindowEx(WS_EX_CLIENTEDGE, TEXT("myWindowClass"), TEXT("Mapping Mode"), WS_VISIBLE | WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, 700, 350, NULL, NULL, hInstance, NULL);
while (GetMessage(&msg, NULL, 0, 0) > 0)
{
TranslateMessage(&msg);
DispatchMessage(&msg);
}
return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, 
WPARAM wParam, LPARAM lParam) {
HDC dc;
PAINTSTRUCT ps;
switch(msg) {
case WM_PAINT:
dc = BeginPaint(hwnd, &ps);
RECT rect; 
GetClientRect (hwnd,&rect);
//draw rectangle with default pen
Rectangle (dc,100, 100, 300, 300); 
//draw rectangle with red pen using mapping mode MM_HIMETRIC
HPEN linecolour;
linecolour=CreatePen(PS_SOLID,1,RGB(255, 0, 0));
SelectObject(dc,linecolour);
SetMapMode (dc,MM_HIMETRIC); 
Rectangle (dc,100, -100, 300, -300);
DeleteObject(linecolour);
//draw rectangle with blue pen using mapping mode MM_LOMETRIC
HPEN linecolour1;
linecolour1=CreatePen(PS_SOLID,1,RGB(0, 0, 255));
SelectObject(dc,linecolour1);
SetMapMode (dc,MM_LOMETRIC); 
Rectangle (dc,100, -100, 300, -300);
DeleteObject(linecolour1);
//draw rectangle with purple pen using mapping mode MM_LOENGLISH
HPEN linecolour2;
linecolour2=CreatePen(PS_SOLID,1,RGB(255, 0, 255));
SetMapMode (dc,MM_LOENGLISH);
SelectObject(dc,linecolour2);
Rectangle (dc,100, -100, 300, -300);
DeleteObject(linecolour2);
//draw rectangle with blue pen using and PS_DASH pen style using mapping mode MM_ANISOTROPIC
SetMapMode (dc,MM_ANISOTROPIC); 
SetWindowExtEx (dc,1, 10,NULL);
SetViewportExtEx (dc,1,1,NULL); 
HPEN linecolour3;
linecolour3=CreatePen(PS_DASH,1,RGB(0, 0, 255));
SelectObject(dc,linecolour3);
Rectangle (dc,100, 300, 300, 500);
DeleteObject(linecolour3);
EndPaint(hwnd, &ps);
break;
case WM_DESTROY:
PostQuitMessage(0);
break; 
}
return DefWindowProc(hwnd, msg, wParam, lParam);
}